;Claw demo for B3D-Exporter V1.3 for Cinema 4D

;This demo shows the new "multi texturing" and "restrict texture to polygons" features and how to use 
;a bone Object in combination with other objects using multiple animations.
;The lightmap was rendered in Cinema4D using "Bake Texture" tags
;The source file uses Cinema4D Release 10(full or demo). To export this scene correctly, use 
;set animation To "second level" in export dialog.

;Textures lava.jpg, penta.jpg, rock2.jpg (c) David Gurrea / www.davegh.com
;Skybox and scene created with Cinema4D by Robert Hierl / www.mein-murks.de 

Const gamma# = 1.3


Graphics3D 1024,768,32,1
SetBuffer BackBuffer()


;set gamma#
For i = 0 To 255
   SetGamma i, i, i, i*gamma#, i*gamma#, i*gamma#
Next
UpdateGamma



;load scenary
mesh = LoadAnimMesh ("claw.b3d")

;load skybox
sky  = LoadMesh ("skybox.b3d")
EntityOrder sky, 1


;Create Camera as Child of "cam" 
camera=CreateCamera(FindChild(mesh, "cam"))
CameraRange camera, 1, 60000


AmbientLight 255,240,240

sndLava = LoadSound("Lava.wav")
LoopSound sndLava
chLava  = PlaySound(sndLava)


Animate FindChild(mesh, "Lava"), 2, 5,0,0.1
Animate FindChild(mesh,"Scene"), 1, 3

time_old = MilliSecs()
While Not KeyHit(1)

;  tweening
   time_new   = MilliSecs()
   time_diff# = (time_new - time_old) / 1000.0
   time_old   = time_new


;  sound handling
   ChannelVolume chLava, 15 / EntityY#(camera,1)
   

   TurnEntity camera, (KeyDown(200) - KeyDown(208)) * time_diff# * 50, (KeyDown(203) - KeyDown(205)) * time_diff# * 50, 0

   UpdateWorld time_diff#

;  skybox
   PositionEntity sky, EntityX#(camera,1), EntityY#(camera,1), EntityZ#(camera,1)

   RenderWorld

   Text 10, 10, "Textures (c) by David Gurrea / www.davegh.com"
   Text 10, 30, "Use arrow keys to look around"

   Flip 1

Wend
End